Index: issm/trunk/src/c/classes/Loads/Penpair.h
===================================================================
--- issm/trunk/src/c/classes/Loads/Penpair.h	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Penpair.h	(revision 18301)
@@ -48,4 +48,5 @@
 			/*Load virtual functions definitions: {{{*/
 		void  Configure(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
+		void  ResetHooks();
 		void  SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
 		void  CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs);
Index: issm/trunk/src/c/classes/Loads/Riftfront.cpp
===================================================================
--- issm/trunk/src/c/classes/Loads/Riftfront.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Riftfront.cpp	(revision 18301)
@@ -20,6 +20,5 @@
 
 /*Riftfront constructors and destructor*/
-/*FUNCTION Riftfront::Riftfront(){{{*/
-Riftfront::Riftfront(){
+Riftfront::Riftfront(){/*{{{*/
 	this->parameters=NULL;
 	this->hnodes=NULL;
@@ -31,6 +30,5 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::Riftfront(int id, int i, IoModel* iomodel,int analysis_type){{{*/
-Riftfront::Riftfront(int riftfront_id,int i, IoModel* iomodel,int riftfront_analysis_type){
+Riftfront::Riftfront(int riftfront_id,int i, IoModel* iomodel,int riftfront_analysis_type){/*{{{*/
 
 	/*data: */
@@ -101,6 +99,5 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::~Riftfront(){{{*/
-Riftfront::~Riftfront(){
+Riftfront::~Riftfront(){/*{{{*/
 	this->parameters=NULL;
 	delete hnodes;
@@ -111,6 +108,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION Riftfront::Echo {{{*/
-void Riftfront::Echo(void){
+void Riftfront::Echo(void){/*{{{*/
 
 	_printf_("Riftfront:\n");
@@ -138,6 +134,5 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::DeepEcho{{{*/
-void Riftfront::DeepEcho(void){
+void Riftfront::DeepEcho(void){/*{{{*/
 
 	_printf_("Riftfront:\n");
@@ -151,9 +146,7 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::Id {{{*/
-int    Riftfront::Id(void){ return id; }
-/*}}}*/
-/*FUNCTION Riftfront::ObjectEnum{{{*/
-int Riftfront::ObjectEnum(void){
+int    Riftfront::Id(void){ return id; }/*{{{*/
+/*}}}*/
+int Riftfront::ObjectEnum(void){/*{{{*/
 
 	return RiftfrontEnum;
@@ -161,6 +154,5 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::copy {{{*/
-Object* Riftfront::copy() {
+Object* Riftfront::copy() {/*{{{*/
 
 	Riftfront* riftfront=NULL;
@@ -209,15 +201,12 @@
 
 /*Update virtual functions definitions:*/
-/*FUNCTION Riftfront::InputUpdateFromConstant(bool constant,int name) {{{*/
-void  Riftfront::InputUpdateFromConstant(bool constant,int name){
-}
-/*}}}*/
-/*FUNCTION Riftfront::InputUpdateFromConstant(IssmDouble constant,int name) {{{*/
-void  Riftfront::InputUpdateFromConstant(IssmDouble constant,int name){
-
-}
-/*}}}*/
-/*FUNCTION Riftfront::InputUpdateFromVector(IssmDouble* constant,int name) {{{*/
-void    Riftfront::InputUpdateFromVector(IssmDouble* vector, int name, int type){
+void  Riftfront::InputUpdateFromConstant(bool constant,int name){/*{{{*/
+}
+/*}}}*/
+void  Riftfront::InputUpdateFromConstant(IssmDouble constant,int name){/*{{{*/
+
+}
+/*}}}*/
+void  Riftfront::InputUpdateFromVector(IssmDouble* vector, int name, int type){/*{{{*/
 
 	_error_("not implemented yet");
@@ -227,6 +216,5 @@
 
 /*Load virtual functions definitions:*/
-/*FUNCTION Riftfront::Configure {{{*/
-void  Riftfront::Configure(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){
+void  Riftfront::Configure(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/	
 
 	/*Take care of hooking up all objects for this element, ie links the objects in the hooks to their respective 
@@ -246,16 +234,27 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::IsPenalty{{{*/
-bool Riftfront::IsPenalty(void){
+void  Riftfront::ResetHooks(){/*{{{*/
+
+	this->nodes=NULL;
+	this->elements=NULL;
+	this->matpar=NULL;
+	this->parameters=NULL;
+
+	/*Get Element type*/
+	this->hnodes->reset();
+	this->helements->reset();
+	this->hmatpar->reset();
+
+}
+/*}}}*/
+bool  Riftfront::IsPenalty(void){/*{{{*/
 	return true;
 }
 /*}}}*/
-/*FUNCTION Riftfront::SetCurrentConfiguration {{{*/
-void  Riftfront::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){
-
-}
-/*}}}*/
-/*FUNCTION Riftfront::PenaltyCreateKMatrix {{{*/
-void  Riftfront::PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,IssmDouble kmax){
+void  Riftfront::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/
+
+}
+/*}}}*/
+void  Riftfront::PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,IssmDouble kmax){/*{{{*/
 
 	/*Retrieve parameters: */
@@ -282,6 +281,5 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::PenaltyCreatePVector {{{*/
-void  Riftfront::PenaltyCreatePVector(Vector<IssmDouble>* pf,IssmDouble kmax){
+void  Riftfront::PenaltyCreatePVector(Vector<IssmDouble>* pf,IssmDouble kmax){/*{{{*/
 
 	/*Retrieve parameters: */
@@ -308,18 +306,15 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::CreateKMatrix {{{*/
-void  Riftfront::CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){
+void  Riftfront::CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs){/*{{{*/
 	/*do nothing: */
 	return;
 }
 /*}}}*/
-/*FUNCTION Riftfront::CreatePVector {{{*/
-void  Riftfront::CreatePVector(Vector<IssmDouble>* pf){
+void  Riftfront::CreatePVector(Vector<IssmDouble>* pf){/*{{{*/
 	/*do nothing: */
 	return;
 }
 /*}}}*/
-/*FUNCTION Riftfront::GetNodesSidList{{{*/
-void Riftfront::GetNodesSidList(int* sidlist){
+void  Riftfront::GetNodesSidList(int* sidlist){/*{{{*/
 
 	_assert_(sidlist);
@@ -329,6 +324,5 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::GetNodesLidList{{{*/
-void Riftfront::GetNodesLidList(int* lidlist){
+void  Riftfront::GetNodesLidList(int* lidlist){/*{{{*/
 
 	_assert_(lidlist);
@@ -338,18 +332,15 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::GetNumberOfNodes{{{*/
-int Riftfront::GetNumberOfNodes(void){
+int   Riftfront::GetNumberOfNodes(void){/*{{{*/
 
 	return NUMVERTICES;
 }
 /*}}}*/
-/*FUNCTION Riftfront::InAnalysis{{{*/
-bool Riftfront::InAnalysis(int in_analysis_type){
+bool  Riftfront::InAnalysis(int in_analysis_type){/*{{{*/
 	if (in_analysis_type==this->analysis_type) return true;
 	else return false;
 }
 /*}}}*/
-/*FUNCTION Riftfront::SetwiseNodeConnectivity{{{*/
-void Riftfront::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int* flagsindices,int set1_enum,int set2_enum){
+void  Riftfront::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int* flagsindices,int set1_enum,int set2_enum){/*{{{*/
 
 	/*Output */
@@ -407,6 +398,5 @@
 
 /*Riftfront numerics*/
-/*FUNCTION Riftfront::PenaltyCreateKMatrixStressbalanceHoriz {{{*/
-ElementMatrix* Riftfront::PenaltyCreateKMatrixStressbalanceHoriz(IssmDouble kmax){
+ElementMatrix* Riftfront::PenaltyCreateKMatrixStressbalanceHoriz(IssmDouble kmax){/*{{{*/
 
 	const int   numdof = NDOF2*NUMVERTICES;
@@ -485,6 +475,5 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::PenaltyCreatePVectorStressbalanceHoriz {{{*/
-ElementVector* Riftfront::PenaltyCreatePVectorStressbalanceHoriz(IssmDouble kmax){
+ElementVector* Riftfront::PenaltyCreatePVectorStressbalanceHoriz(IssmDouble kmax){/*{{{*/
 
 	int        j;
@@ -580,8 +569,6 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::Constrain {{{*/
 #define _ZIGZAGCOUNTER_
-
-int Riftfront::Constrain(int* punstable){
+int    Riftfront::Constrain(int* punstable){/*{{{*/
 
 	IssmDouble  penetration;
@@ -664,6 +651,5 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::FreezeConstraints{{{*/
-void   Riftfront::FreezeConstraints(void){
+void   Riftfront::FreezeConstraints(void){/*{{{*/
 
 	/*Just set frozen flag to 1: */
@@ -672,6 +658,5 @@
 }
 /*}}}*/
-/*FUNCTION Riftfront::IsFrozen{{{*/
-bool   Riftfront::IsFrozen(void){
+bool   Riftfront::IsFrozen(void){/*{{{*/
 
 	/*Just set frozen flag to 1: */
Index: issm/trunk/src/c/classes/Loads/Riftfront.h
===================================================================
--- issm/trunk/src/c/classes/Loads/Riftfront.h	(revision 18081)
+++ issm/trunk/src/c/classes/Loads/Riftfront.h	(revision 18301)
@@ -74,4 +74,5 @@
 		/*Load virtual functions definitions: {{{*/
 		void  Configure(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
+		void  ResetHooks();
 		void  SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
 		void  CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs);
Index: issm/trunk/src/c/classes/Massfluxatgate.h
===================================================================
--- issm/trunk/src/c/classes/Massfluxatgate.h	(revision 18081)
+++ issm/trunk/src/c/classes/Massfluxatgate.h	(revision 18301)
@@ -29,6 +29,5 @@
 
 		/*Massfluxatgate constructors, destructors :*/
-		/*FUNCTION Massfluxatgate() {{{*/
-		Massfluxatgate(){
+		Massfluxatgate(){/*{{{*/
 			this->name        = 0;
 			this->numsegments = 0;
@@ -36,6 +35,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION Massfluxatgate(char* name, int numsegments, doubletype* segments) {{{*/
-		Massfluxatgate(char* in_name, int in_numsegments, doubletype* in_segments) {
+		Massfluxatgate(char* in_name, int in_numsegments, doubletype* in_segments) {/*{{{*/
 			
 			int i;
@@ -63,6 +61,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION Massfluxatgate(char* name, int numsegments, doubletype* x1, doubletype* y1, doubletype* x2, doubletype* y2,int* elements) {{{*/
-		Massfluxatgate(char* in_name, int in_numsegments, doubletype* in_x1, doubletype* in_y1, doubletype* in_x2, doubletype* in_y2,int* in_elements){
+		Massfluxatgate(char* in_name, int in_numsegments, doubletype* in_x1, doubletype* in_y1, doubletype* in_x2, doubletype* in_y2,int* in_elements){/*{{{*/
 
 			this->name   = xNew<char>(strlen(in_name)+1);
@@ -81,6 +78,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION ~Massfluxatgate() {{{*/
-		~Massfluxatgate(){
+		~Massfluxatgate(){/*{{{*/
 			xDelete<doubletype>(this->x1);
 			xDelete<doubletype>(this->y1);
@@ -93,6 +89,5 @@
 
 		/*Object virtual function resolutoin: */
-		/*FUNCTION Echo(){{{*/
-		void Echo(void){
+		void Echo(void){/*{{{*/
 			_printf_(" Massfluxatgate: " << name << "\n");
 			_printf_("    numsegments: " << numsegments << "\n");
@@ -105,27 +100,22 @@
 		}
 		/*}}}*/
-		/*FUNCTION DeepEcho(){{{*/
-		void DeepEcho(void){
+		void DeepEcho(void){/*{{{*/
 			this->Echo();
 		}
 		/*}}}*/
-		/*FUNCTION Id(){{{*/
-		int Id(void){
+		int Id(void){/*{{{*/
 			return -1;
 		}
 		/*}}}*/
-		/*FUNCTION ObjectEnum{{{*/
-		int ObjectEnum(void){
+		int ObjectEnum(void){/*{{{*/
 			return MassfluxatgateEnum;
 		}
 		/*}}}*/
-		/*FUNCTION copy {{{*/
-		Object* copy() {
+		Object* copy() {/*{{{*/
 			return new Massfluxatgate(this->name,this->numsegments,this->x1,this->y1,this->x2,this->y2,this->elements); 
 		}
 		/*}}}*/
 		/*Definition virtual function resolutoin: */
-		/*FUNCTION char* Name() {{{*/
-		char* Name(){
+		char* Name(){/*{{{*/
 
 			char* name2=xNew<char>(strlen(this->name)+1);
@@ -135,6 +125,5 @@
 		}
 		/*}}}*/
-		/*FUNCTION doubletype* Response(FemModel* femmodel) {{{*/
-		 IssmDouble Response(FemModel* femmodel){
+		 IssmDouble Response(FemModel* femmodel){/*{{{*/
 
 			int          i,j;
Index: issm/trunk/src/c/classes/Materials/Material.h
===================================================================
--- issm/trunk/src/c/classes/Materials/Material.h	(revision 18081)
+++ issm/trunk/src/c/classes/Materials/Material.h	(revision 18301)
@@ -26,4 +26,6 @@
 		virtual void       Configure(Elements* elements)=0;
 		virtual void       GetViscosity(IssmDouble* pviscosity,IssmDouble epseff)=0;
+		virtual void       GetViscosity_B(IssmDouble* pviscosity,IssmDouble epseff)=0;
+		virtual void       GetViscosity_D(IssmDouble* pviscosity,IssmDouble epseff)=0;
 		virtual void       GetViscosityBar(IssmDouble* pviscosity,IssmDouble epseff)=0;
 		virtual void       GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon)=0;
@@ -39,4 +41,5 @@
 		virtual IssmDouble GetDbar()=0;
 		virtual bool       IsDamage()=0;
+		virtual void       ResetHooks()=0;
 
 };
Index: issm/trunk/src/c/classes/Materials/Materials.cpp
===================================================================
--- issm/trunk/src/c/classes/Materials/Materials.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Materials/Materials.cpp	(revision 18301)
@@ -19,12 +19,10 @@
 
 /*Object constructors and destructor*/
-/*FUNCTION Materials::Materials(){{{*/
-Materials::Materials(){
+Materials::Materials(){/*{{{*/
 	enum_type=MaterialsEnum;
 	return;
 }
 /*}}}*/
-/*FUNCTION Materials::~Materials(){{{*/
-Materials::~Materials(){
+Materials::~Materials(){/*{{{*/
 	return;
 }
@@ -32,6 +30,5 @@
 
 /*Object management*/
-/*FUNCTION Materials::Configure{{{*/
-void Materials::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){
+void Materials::Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters){/*{{{*/
 
 	vector<Object*>::iterator object;
@@ -47,2 +44,16 @@
 }
 /*}}}*/
+void Materials::ResetHooks(){/*{{{*/
+
+	vector<Object*>::iterator object;
+	Material* material=NULL;
+
+	for ( object=objects.begin() ; object < objects.end(); object++ ){
+
+		material=dynamic_cast<Material*>((*object));
+		material->ResetHooks();
+
+	}
+
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/Materials/Materials.h
===================================================================
--- issm/trunk/src/c/classes/Materials/Materials.h	(revision 18081)
+++ issm/trunk/src/c/classes/Materials/Materials.h	(revision 18301)
@@ -24,4 +24,5 @@
 		/*numerics*/
 		void  Configure(Elements* elements,Loads* loads, Nodes* nodes, Vertices* vertices, Materials* materials,Parameters* parameters);
+		void  ResetHooks();
 
 };
Index: issm/trunk/src/c/classes/Materials/Matice.cpp
===================================================================
--- issm/trunk/src/c/classes/Materials/Matice.cpp	(revision 18081)
+++ issm/trunk/src/c/classes/Materials/Matice.cpp	(revision 18301)
@@ -27,6 +27,5 @@
 
 /*Matice constructors and destructor*/
-/*FUNCTION Matice::Matice(){{{*/
-Matice::Matice(){
+Matice::Matice(){/*{{{*/
 	this->helement=NULL;
 	this->element=NULL;
@@ -34,6 +33,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::Matice(int id, int index, IoModel* iomodel, int num_vertices){{{*/
-Matice::Matice(int matice_mid,int index, IoModel* iomodel){
+Matice::Matice(int matice_mid,int index, IoModel* iomodel){/*{{{*/
 
 	/*Intermediaries:*/
@@ -59,6 +57,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::~Matice(){{{*/
-Matice::~Matice(){
+Matice::~Matice(){/*{{{*/
 	delete helement;
 	return;
@@ -67,6 +64,5 @@
 
 /*Object virtual functions definitions:*/
-/*FUNCTION Matice::Echo {{{*/
-void Matice::Echo(void){
+void Matice::Echo(void){/*{{{*/
 
 	_printf_("Matice:\n");
@@ -76,6 +72,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::DeepEcho {{{*/
-void Matice::DeepEcho(void){
+void Matice::DeepEcho(void){/*{{{*/
 
 	_printf_("Matice:\n");
@@ -85,9 +80,7 @@
 }		
 /*}}}*/
-/*FUNCTION Matice::Id {{{*/
-int    Matice::Id(void){ return mid; }
-/*}}}*/
-/*FUNCTION Matice::ObjectEnum{{{*/
-int Matice::ObjectEnum(void){
+int    Matice::Id(void){ return mid; }/*{{{*/
+/*}}}*/
+int Matice::ObjectEnum(void){/*{{{*/
 
 	return MaticeEnum;
@@ -95,6 +88,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::copy() {{{*/
-Object* Matice::copy() {
+Object* Matice::copy() {/*{{{*/
 
 	/*Output*/
@@ -113,6 +105,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::copy2(Element* element) {{{*/
-Material* Matice::copy2(Element* element_in) {
+Material* Matice::copy2(Element* element_in) {/*{{{*/
 
 	/*Output*/
@@ -133,6 +124,5 @@
 
 /*Matice management*/
-/*FUNCTION Matice::Configure {{{*/
-void  Matice::Configure(Elements* elementsin){
+void  Matice::Configure(Elements* elementsin){/*{{{*/
 
 	/*Take care of hooking up all objects for this element, ie links the objects in the hooks to their respective 
@@ -142,11 +132,9 @@
 }
 /*}}}*/
-/*FUNCTION Matice::SetCurrentConfiguration {{{*/
-void  Matice::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){
-
-}
-/*}}}*/
-/*FUNCTION Matice::GetA {{{*/
-IssmDouble Matice::GetA(){
+void  Matice::SetCurrentConfiguration(Elements* elementsin,Loads* loadsin,Nodes* nodesin,Vertices* verticesin,Materials* materialsin,Parameters* parametersin){/*{{{*/
+
+}
+/*}}}*/
+IssmDouble Matice::GetA(){/*{{{*/
 	/*
 	 * A = 1/B^n
@@ -161,6 +149,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetAbar {{{*/
-IssmDouble Matice::GetAbar(){
+IssmDouble Matice::GetAbar(){/*{{{*/
 	/*
 	 * A = 1/B^n
@@ -175,6 +162,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetB {{{*/
-IssmDouble Matice::GetB(){
+IssmDouble Matice::GetB(){/*{{{*/
 
 	/*Output*/
@@ -185,6 +171,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetBbar {{{*/
-IssmDouble Matice::GetBbar(){
+IssmDouble Matice::GetBbar(){/*{{{*/
 
 	/*Output*/
@@ -195,6 +180,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetN {{{*/
-IssmDouble Matice::GetN(){
+IssmDouble Matice::GetN(){/*{{{*/
 
 	/*Output*/
@@ -205,6 +189,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetD {{{*/
-IssmDouble Matice::GetD(){
+IssmDouble Matice::GetD(){/*{{{*/
 
 	_assert_(this->isdamaged);
@@ -215,6 +198,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetDbar {{{*/
-IssmDouble Matice::GetDbar(){
+IssmDouble Matice::GetDbar(){/*{{{*/
 
 	_assert_(this->isdamaged);
@@ -225,12 +207,10 @@
 }
 /*}}}*/
-/*FUNCTION Matice::IsDamage() {{{*/
-bool Matice::IsDamage(){
+bool Matice::IsDamage(){/*{{{*/
 
 	return this->isdamaged;
 }
 /*}}}*/
-/*FUNCTION Matice::GetViscosity {{{*/
-void  Matice::GetViscosity(IssmDouble* pviscosity,IssmDouble eps_eff){
+void  Matice::GetViscosity(IssmDouble* pviscosity,IssmDouble eps_eff){/*{{{*/
 	/*From a string tensor and a material object, return viscosity, using Glen's flow law.
 								(1-D) B
@@ -284,6 +264,59 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetViscosityBar {{{*/
-void  Matice::GetViscosityBar(IssmDouble* pviscosity,IssmDouble eps_eff){
+void  Matice::GetViscosity_B(IssmDouble* pdmudB,IssmDouble eps_eff){/*{{{*/
+
+	/*output: */
+	IssmDouble dmudB;
+
+	/*Intermediary: */
+	IssmDouble D=0.,n;
+
+	/*Get B and n*/
+	n=GetN(); _assert_(n>0.);
+	if(this->isdamaged){
+		D=GetD();
+		_assert_(D>=0. && D<1.);
+	}
+
+	if(n==1.){
+		/*Linear Viscous behavior (Newtonian fluid) dmudB=B/2: */
+		dmudB=(1.-D)/2.;
+	}
+	else{
+		if(eps_eff==0.) dmudB = 0.;
+		else            dmudB = (1.-D)/(2.*pow(eps_eff,(n-1.)/n));
+	}
+
+	/*Return: */
+	*pdmudB=dmudB;
+}
+/*}}}*/
+void  Matice::GetViscosity_D(IssmDouble* pdmudD,IssmDouble eps_eff){/*{{{*/
+
+	/*output: */
+	IssmDouble dmudD;
+
+	/*Intermediary: */
+	IssmDouble n,B;
+
+	/*Get B and n*/
+	n=GetN(); _assert_(n>0.);
+	B=GetBbar();
+	_assert_(this->isdamaged);
+
+	if(n==1.){
+		/*Linear Viscous behavior (Newtonian fluid) dmudB=B/2: */
+		dmudD=-B/2.;
+	}
+	else{
+		if(eps_eff==0.) dmudD = 0.;
+		else            dmudD = -B/(2.*pow(eps_eff,(n-1.)/n));
+	}
+
+	/*Return: */
+	*pdmudD=dmudD;
+}
+/*}}}*/
+void  Matice::GetViscosityBar(IssmDouble* pviscosity,IssmDouble eps_eff){/*{{{*/
 	/*From a string tensor and a material object, return viscosity, using Glen's flow law.
 								(1-D) B
@@ -336,6 +369,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetViscosityComplement {{{*/
-void  Matice::GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* epsilon){
+void  Matice::GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* epsilon){/*{{{*/
 	/*Return viscosity accounting for steady state power law creep [Thomas and SSA, 1982]: 
 	 *
@@ -395,6 +427,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetViscosityDComplement {{{*/
-void  Matice::GetViscosityDComplement(IssmDouble* pviscosity_complement, IssmDouble* epsilon){
+void  Matice::GetViscosityDComplement(IssmDouble* pviscosity_complement, IssmDouble* epsilon){/*{{{*/
 	/*Return viscosity derivative for control method d(mu)/dD: 
 	 *
@@ -451,6 +482,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetViscosityDerivativeEpsSquare{{{*/
-void  Matice::GetViscosityDerivativeEpsSquare(IssmDouble* pmu_prime, IssmDouble* epsilon){
+void  Matice::GetViscosityDerivativeEpsSquare(IssmDouble* pmu_prime, IssmDouble* epsilon){/*{{{*/
 
 	/*output: */
@@ -485,6 +515,5 @@
 }
 /*}}}*/
-/*FUNCTION Matice::GetViscosity2dDerivativeEpsSquare{{{*/
-void  Matice::GetViscosity2dDerivativeEpsSquare(IssmDouble* pmu_prime, IssmDouble* epsilon){
+void  Matice::GetViscosity2dDerivativeEpsSquare(IssmDouble* pmu_prime, IssmDouble* epsilon){/*{{{*/
 
 	/*output: */
@@ -514,32 +543,35 @@
 }
 /*}}}*/
-/*FUNCTION Matice::InputUpdateFromVector(IssmDouble* vector, int name, int type) {{{*/
-void  Matice::InputUpdateFromVector(IssmDouble* vector, int name, int type){
-
-}
-/*}}}*/
-/*FUNCTION Matice::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type) {{{*/
-void  Matice::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type){
-
-}
-/*}}}*/
-/*FUNCTION Matice::InputUpdateFromMatrixDakota(int* vector, int name, int type) {{{*/
-void  Matice::InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrows, int ncols,int name, int type){
+void  Matice::InputUpdateFromVector(IssmDouble* vector, int name, int type){/*{{{*/
+
+}
+/*}}}*/
+void  Matice::InputUpdateFromVectorDakota(IssmDouble* vector, int name, int type){/*{{{*/
+
+}
+/*}}}*/
+void  Matice::InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrows, int ncols,int name, int type){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Matice::InputUpdateFromConstant(IssmDouble constant, int name) {{{*/
-void  Matice::InputUpdateFromConstant(IssmDouble constant, int name){
+void  Matice::InputUpdateFromConstant(IssmDouble constant, int name){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Matice::InputUpdateFromConstant(int constant, int name) {{{*/
-void  Matice::InputUpdateFromConstant(int constant, int name){
+void  Matice::InputUpdateFromConstant(int constant, int name){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
-/*FUNCTION Matice::InputUpdateFromConstant(bool constant, int name) {{{*/
-void  Matice::InputUpdateFromConstant(bool constant, int name){
+void  Matice::InputUpdateFromConstant(bool constant, int name){/*{{{*/
 	/*Nothing updated yet*/
 }
 /*}}}*/
+void  Matice::ResetHooks(){/*{{{*/
+
+	this->element=NULL;
+
+	/*Get Element type*/
+	this->helement->reset();
+
+}
+/*}}}*/
Index: issm/trunk/src/c/classes/Materials/Matice.h
===================================================================
--- issm/trunk/src/c/classes/Materials/Matice.h	(revision 18081)
+++ issm/trunk/src/c/classes/Materials/Matice.h	(revision 18301)
@@ -41,5 +41,5 @@
 		Object* copy();
 		/*}}}*/
-		/*Update virtual functions definitions: {{{*/
+		/*Update virtual funictions definitions: {{{*/
 		void  InputUpdateFromVector(IssmDouble* vector, int name, int type);
 		void  InputUpdateFromMatrixDakota(IssmDouble* matrix, int nrow, int ncols, int name, int type);
@@ -55,4 +55,6 @@
 		void       SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters);
 		void       GetViscosity(IssmDouble* pviscosity, IssmDouble eps_eff);
+		void       GetViscosity_B(IssmDouble* pviscosity, IssmDouble eps_eff);
+		void       GetViscosity_D(IssmDouble* pviscosity, IssmDouble eps_eff);
 		void       GetViscosityBar(IssmDouble* pviscosity, IssmDouble eps_eff);
 		void       GetViscosityComplement(IssmDouble* pviscosity_complement, IssmDouble* pepsilon);
@@ -68,4 +70,5 @@
 		IssmDouble GetN();
 		bool       IsDamage();
+		void       ResetHooks();
 		/*}}}*/
 };
